global gDataStart, gDataStop, gDataFile, FileIO, gStoredTime, gAutomated, gWhichAutomatedClip, gLoadedTimeCodes, gCDTitle, gStarPower

on readDataFile
  if the machineType = 256 then
    openXLib("FileIO.DLL")
    set gDataFile to FileIO(mnew, "?read", "TXT")
  else
    set gDataFile to FileIO(mnew, "?read", "TEXT")
  end if
  if objectp(gDataFile) = 0 then
    errorMessage()
    go(the frame)
  else
    set adjustedTimeCodes to gDataFile(mReadFile)
    if line 1 of adjustedTimeCodes contains gCDTitle then
      do("set adjustedTimeCodes=" & line 3 of adjustedTimeCodes)
      if developersKey() then
        put adjustedTimeCodes
      end if
      if checkTimeCodes(adjustedTimeCodes) = 0 then
        readDataFile()
        exit
      else
        set gStarPower to 1
        set gAutomated to 1
        set gLoadedTimeCodes to adjustedTimeCodes
        set gRecording to 0
        set the timeoutScript to "nothing"
        set gWhichAutomatedClip to 1
        correlateSliderPositionsToMovieTime()
        set gStoredTime to []
        sort(gStoredTime)
        set gAutomatedTimes to []
        sort(gAutomatedTimes)
        set gWhichAutomatedClip to 1
        advanceAutomatedMovie()
      end if
    else
      readDataFile()
      exit
    end if
  end if
end

on writeData theData
  set gDataFile to gDataFile & theData & RETURN
end

on writeDataFile whichData
  if the machineType = 256 then
    openXLib("FileIO.DLL")
  end if
  set gDataFile to FileIO(mnew, "?write", EMPTY)
  if objectp(gDataFile) = 0 then
    errorMessage()
  else
    gDataFile(mWriteString, "Digital Playground FantaSave (TM) data for " & gCDTitle & "." & RETURN & RETURN)
    if voidp(whichData) then
      set whichData to gStoredTime
    end if
    gDataFile(mWriteString, string(whichData & RETURN))
    if objectp(gDataFile) <> 0 then
      gDataFile(mdispose)
    end if
  end if
end

on errorMessage
  if gDataFile = -43 then
    nothing()
  else
    if (gDataFile = -33) or (gDataFile = -34) then
      alert("This volume is full.")
    else
      alert("File I/O object was not made." & RETURN & "Error: " & string(gDataFile))
      if not (the shiftDown) then
        beep(2)
      end if
    end if
  end if
end

on stringEntry
  writeData(EMPTY)
end
