global gMovie1TimeCodes, gMovie2TimeCodes, gMovie3TimeCodes, gMovie4TimeCodes, gMovie5TimeCodes, gMovie6TimeCodes, gMovie7TimeCodes, gMovie8TimeCodes, gMovie9TimeCodes, gWhichMovie, gWhichClip, gMarkerSlots, gFrames, gLabels, gPreviousTime, gStoredTime, gSliderPositions, gMovieSprite, gStartTime, gStopTime, gBDrop, gFullScreen, gWhichCamera, gSliderCorrelation, gSliderCorrelationCount, gFloatingSprite, gAutomated, gAutomatedTimes, gWhichAutomatedClip, gRecording, gPlaying, gSliderSprite, gMarkers, gMinH, gMaxH, gFrame00

on getCast whichCast
  if stringp(whichCast) then
    set whichCast to the number of member whichCast
  end if
  set whichCast to whichCast mod 32768
  return whichCast
end

on setProp startSprite, endSprite, whichProperty, whichValue
  set oldTrace to the trace
  set the trace to 0
  repeat with x = startSprite to endSprite
    do("set the " & whichProperty & " of sprite x=" & whichValue)
  end repeat
  set the trace to oldTrace
end

on unloadQT
  set returnFrame to the frame
  set the locV of sprite gMovieSprite to -640
  updateStage()
  set whichClass to class()
  go(getAt(gFrame00, whichClass))
  unLoad()
  unloadMember()
  go(returnFrame)
end

on QT whichSprite
  if the type of sprite whichSprite > 0 then
    if the castLibNum of sprite whichSprite = the number of castLib "iMovies" then
      return 1
      exit
    end if
  end if
  return 0
end

on stopAllQT
  repeat with x = 1 to 48
    if the type of sprite x > 0 then
      set whichMember to the memberNum of sprite x
      if whichMember > 0 then
        if the type of member whichMember = #digitalVideo then
          set the movieRate of sprite x to 0
        end if
      end if
    end if
  end repeat
  updateStage()
end

on stopAllSound
  sound stop 1
  sound stop 2
  puppetSound("Null Sound")
  puppetSound(0)
  updateStage()
end

on highlightSelection storeVar
  set whichClass to class()
  setProp(26, 29, "puppet", 0)
  if gAutomated <> 1 then
    swapPlaybackScreen("playback dot", 1)
  end if
  set whichSprite to 17 + getAt(gWhichMovie, whichClass)
  puppetSprite(whichSprite, 1)
  set the ink of sprite whichSprite to 0
  set the backColor of sprite whichSprite to 0
  set whichSprite to 23 + getAt(gWhichClip, whichClass)
  puppetSprite(whichSprite, 1)
  set the ink of sprite whichSprite to 0
  set the backColor of sprite whichSprite to 0
  updateStage()
end

on correlateSliderPositionsToMovieTime
  if listp(gAutomatedTimes) = 0 then
    exit
  end if
  set theCount to count(gAutomatedTimes)
  if theCount = 0 then
    exit
  end if
  set gSliderCorrelation to []
  sort(gSliderCorrelation)
  set gSliderPositions to []
  sort(gSliderPositions)
  set lTotalDuration to 0
  repeat with x = 1 to theCount
    set timeCodeX to getAt(gAutomatedTimes, x)
    if listp(timeCodeX) then
      set lWhichMovie to getAt(timeCodeX, 1)
      set lWhichClip to getAt(timeCodeX, 2)
      set numberOfClips to 0
      do("set numberOfClips=value ( count ( gMovie" & lWhichMovie & "TimeCodes ))")
      set lWhichClip to checkRange(lWhichClip, 1, numberOfClips)
      set lWhichCamera to getAt(timeCodeX, 3)
      set lStartTime to getAt(timeCodeX, 4)
      set lStopTime to getAt(timeCodeX, 5)
      repeat with MovieFrame = lStartTime to lStopTime
        append(gSliderCorrelation, [lWhichMovie, lWhichClip, lWhichCamera, MovieFrame, x])
        set MovieFrame to MovieFrame + 5
      end repeat
      set lDuration to lStopTime - lStartTime
      setAt(gSliderPositions, x, lDuration)
      set lTotalDuration to lTotalDuration + lDuration
    end if
  end repeat
  set gSliderCorrelationCount to count(gSliderCorrelation)
  set minH to 0
  set maxH to 0
  set lMinH to 113
  set lMaxH to 254
  set sliderLength to lMaxH - lMinH
  if lTotalDuration < 1 then
    set lTotalDuration to 1
  end if
  set newCount to count(gSliderPositions)
  repeat with x = 1 to newCount
    set whichCodesX to getAt(gAutomatedTimes, x)
    if listp(whichCodesX) then
      set clipDuration to getAt(gSliderPositions, x)
      set thePercentage to clipDuration * 1.0 / lTotalDuration * sliderLength
      set maxH to integer(minH + thePercentage)
      set maxSlider to sliderLength - (theCount - x)
      if minH > maxSlider then
        set minH to maxSlider
      end if
      if maxH > maxSlider then
        set maxH to maxSlider
      end if
      if (minH < 0) or (maxH < 0) then
        put RETURN
        put "Warning: minH: " & minH & " maxH: " & maxH
        put "0: theCount: " & theCount & " x: " & x & " sliderLength -( theCount -x ): " & sliderLength - (theCount - x)
        put "1: clipDuration: " & clipDuration & " lTotalDuration: " & lTotalDuration & " sliderLength: " & sliderLength
      end if
      setAt(whichCodesX, 6, minH + lMinH)
      setAt(whichCodesX, 7, maxH + lMinH)
      setAt(gAutomatedTimes, x, whichCodesX)
      set minH to maxH + 1
    end if
  end repeat
end

on getMarkerName
  return getaProp(gFrames, marker(0))
end

on getMarkerFrame whichLabel
  return getaProp(gLabels, whichLabel)
end

on initMarkerList
  set theLabelList to the labelList
  set gMarkerSlots to [:]
  repeat with x = 1 to the number of lines in theLabelList
    set labelX to label(x)
    set stringX to string(line x of theLabelList)
    do("addProp gFrames, #" & labelX & ", stringX")
    do("addProp gLabels, #" & stringX & ", labelX")
  end repeat
end

on checkCodes
  set codes to [[60, 3226], [3288, 6454], [6516, 9904], [9966, 13354], [13416, 14144], [14206, 14934], [14996, 16848], [16910, 18762], [18824, 21760], [21822, 24758], [24820, 25754], [25816, 26750], [26812, 30310], [30372, 33870], [33932, 37574], [37636, 41278], [41340, 42210], [42272, 43142], [43204, 46760], [46822, 50378], [50440, 54212], [54274, 58046], [58108, 58996], [59058, 59946], [60008, 63666], [63728, 67386], [67448, 70740], [70802, 74094], [74156, 75960], [76022, 77826]]
  set codes to [[77886, 78696], [78758, 79034], [79096, 79272], [79334, 79438], [79500, 79768], [79830, 80040], [80102, 80356], [80418, 80602], [80664, 80836], [80898, 84242, 84304, 87648], [87710, 90848, 90910, 94048], [94110, 96034, 96096, 98020], [98082, 101428, 101490, 104836], [104898, 108288, 108350, 111740], [111802, 113386, 113448, 115032], [115094, 118666, 118728, 122300], [122362, 125570, 125632, 128840], [128902, 130518, 130580, 132196]]
  set codes to [[80898, 84242], [84304, 87648], [87710, 90848], [90910, 94048], [94110, 96034], [96096, 98020], [98082, 101428], [101490, 104836], [104898, 108288], [108350, 111740], [111802, 113386], [113448, 115032], [115094, 118666], [118728, 122300], [122362, 125570], [125632, 128840], [128902, 130518], [130580, 132196]]
  repeat with x = 1 to count(codes)
    set timeCodesX to getAt(codes, x)
    set startTimeCode to value(getAt(timeCodesX, 1))
    set stopTimeCode to value(getAt(timeCodesX, 2))
    put x & ". startTime: " & startTimeCode & " stopTime: " & stopTimeCode & " duration: " & stopTimeCode - startTimeCode
    if (x mod 2) = 0 then
      put EMPTY
    end if
  end repeat
end
